/*
 *	main.c
 *
 *	\eBAwt[Zx
 *
 *	* Tue Sep 24 05:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬Jn
 */
#include "app.h"

extern unsigned char PAT[];
extern unsigned char BG[];
extern unsigned char AYAKA[];
#include "snd/s1.c"
#include "snd/s2.c"
#include "snd/s3.c"
#include "snd/s4.c"

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/* J[hCfbNX
 *	00-0c	Xy[h``j
 *	10-1c	_C@``j
 *	20-2c	Nu@``j
 *	30-3c	n[g@``j
 */
#define CARD_MARK(c)		(((c) >> 4) & 0xf)
#define CARD_NO(c)		(((c) >> 0) & 0xf)
#define CARD_MAKE(m, n)		(((m) & 0xf) << 4 | ((n) & 0xf) << 0)
//#define CARD_REV		0x41	/* (\p) */
#define CARD_NUL		0x42	/* (\p) */
#define CARD_NORMAL		0x4b	/* ʏwi(\p) */
#define CARD_SELECT		0x4c	/* Iwi(\p) */

/* ICfbNX
 * TYPE=SEL_BA
 *	COL=0-7 I
 * TYPE=SEL_FREE
 *	COL=0-3 I
 * TYPE=SEL_HOME
 *	COL=0-3 I
 */
#define SEL_BA			0
#define SEL_FREE		1
#define SEL_HOME		2
#define SEL_TYPE(s)		(((s) >> 8) & 0xff)
#define SEL_COL(s)		(((s) >> 0) & 0xff)
#define SEL_MAKE(t, c)		(((t) & 0xff) << 8 | ((c) & 0xff) << 0)

typedef struct _SEL {
	int src;	/* ړ */
	int dst[52];	/* ړ惊Xg */
	int n_dst;	/* ړ̐ */
	int i_dst;	/* ړI */
} SEL;

typedef struct _GAMEINFO {
	int time;			/* oߎ */
	int gameover;			/* Q[I[o[(s)tO */
	/* J[h */
	unsigned char ba[8][52];	/* D */
	unsigned char n_ba[8];		/* D̐ */
	unsigned char free[4];		/* t[Z(CARD_NUL) */
	unsigned char home[4];		/* z[Z(CARD_NUL) */
	/* I */
	SEL sel[52];			/* ړXg */
	int n_sel;			/* ړ̐   */
	int i_sel;			/* ړI   */
	/* \ */
	int top;			/* \[C */
	int bottom;			/* `扺[C */
} GAMEINFO;

unsigned char dashes[] = {1,2,3,4,4};	/* KChp^[ */
#define MOVE_STEP	SEC(0.25)	/* ړXebv */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

PIECE_BMP pat, bg, ayaka;		/* rbg}bv */

int best_time = SEC(100 * 60 * 60) - 1;	/* xXg^C */
GAMEINFO gi;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void game_init();
void sound(int no);
void stredge(int x, int y, const char* str, int outcol, int incol);
void timestr(char* str, int time);
void card_disp(int x, int y, unsigned char card, int sel);
void field_disp(int step);
int find_sel(SEL sel[52]);
int find_dst(int src, int dst[52]);
void do_move(int src, int dst);
int trust(int src, int dst);

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	gi.gameover = 1; /* ^Cgł1P^C\}̂ */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* rbg}bvB */
	texture_init(&pat, PAT);
	texture_init(&bg, BG);
	texture_init(&ayaka, AYAKA);

	/* TEh{[őɁB */
	pceWaveSetChAtt(0, 0);

	/* B */
	srand(pceTimerGetCount());
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	/* mɃTEh~܂B */
	pceWaveStop(0);
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5)		/* PAUSEbZ[W̉ */
#define PAUSE_H		10		/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

	int pause, x, y;
	unsigned char save[PAUSE_H][PAUSE_W];

	pause = 0;
	for(;;) {
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */

		/* PAUSEB */
		if(joy & TRG_START) {
			pause ^= 1;	/* PAUSEԐ؂ւ */
			if(pause & 1) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
		if(!(pause & 1)) break;

		/* PAUSEbZ[W_ŕ\B */
		pceFontSetType(PAUSE_FONT);
		pceFontSetTxColor(pause & 2 ? 2 : 3);
		pceFontSetBkColor(pause & 2 ? 0 : 1);
		pceFontSetPos(PAUSE_X, PAUSE_Y);
		pceFontPutStr(PAUSE_STR);
		pause ^= 2;
	}
	now++;	/* O[o^C}XV */

#undef PAUSE_FONT
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	unsigned char* p, c;
	char str[32];
	int x, y;

	for(;;) {
		schedule();

		/* X^[gHIH */
		if(joy & TRG_SELECT) return -1;
		if(joy & TRG_A     ) return 0;

		/* ʃNAB */
		p = vbuff;
		c = 1;
		for(y = 0; y < DISP_Y; y++, c ^= 1) {
			for(x = 0; x < DISP_X; x++, c ^= 1) {
				*p++ = c;
			}
		}

		/* ^Cg\B */
		pceFontSetBkColor(-1);
		pceFontSetType(0x80);
		strcpy(str, "\eBA");
		x = (DISP_X - 5 * strlen(str)) / 2;
		y = 27;
		stredge(x, y, str, 3, 1);
		pceFontSetType(0x81);
		strcpy(str, "FREECELL");
		x = (DISP_X - 8 * strlen(str)) / 2 + 1;
		y = 38;
		stredge(x, y, str, 3, 2);

		/* XRA\B */
		pceFontSetType(0x82);
		x = (DISP_X - 4 * 8) / 2;
		y = 2;
		strcpy(str, "BESTTIME");
		stredge(x, y, str, 3, 0);
		y += 8;
		timestr(str, best_time);
		stredge(x, y, str, 3, 0);
		if(!gi.gameover) { /* ÕQ[ꍇ̂1P^C\ */
			timestr(str, gi.time);
			x = (DISP_X - 4 * 8) / 2;
			y = DISP_Y - 6;
			stredge(x, y, str, 3, 0);
		}

		/* vvg\B */
		if(now % SEC(1.0) < SEC(0.67)) {
			pceFontSetType(0x82);
			strcpy(str, "A  START");
			x = (DISP_X - 4 * strlen(str)) / 2;
			y = DISP_Y - 28;
			stredge(x, y, str, 3, 0);
			strcpy(str, "SEL EXIT");
			x = (DISP_X - 4 * strlen(str)) / 2;
			y += 8;
			stredge(x, y, str, 3, 0);
		}
	}

	return 0; /* _~[ */
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	int i, x, y;
	const char* str;

	game_init();

	sound(2);
	for(;;) {
		schedule();
		gi.time++;

		/* f */
		if(joy & TRG_SELECT) {
			gi.gameover = 1;
			break;
		}

		/* mȈړȂAɎsB */
		if(trust(gi.sel[gi.i_sel].src,
		         gi.sel[gi.i_sel].dst[gi.sel[gi.i_sel].i_dst])) goto DO_MOVE;

		/* ړIύX */
		if(joy & TRG_LF) {
			if(gi.n_sel > 1) {
				sound(3);
				if(--gi.i_sel == -1)
				     gi.i_sel = gi.n_sel - 1;
			} else {
				sound(1);
			}
		} else if(joy & TRG_RI) {
			if(gi.n_sel > 1) {
				sound(3);
				if(++gi.i_sel == gi.n_sel)
				     gi.i_sel = 0;
			} else {
				sound(1);
			}
		/* ړIύX */
		} else if(joy & TRG_UP) {
			if(gi.sel[gi.i_sel].n_dst > 1) {
				sound(3);
				if(--gi.sel[gi.i_sel].i_dst == -1)
				     gi.sel[gi.i_sel].i_dst = gi.sel[gi.i_sel].n_dst - 1;
			} else {
				sound(1);
			}
		} else if(joy & TRG_DN) {
			if(gi.sel[gi.i_sel].n_dst > 1) {
				sound(3);
				if(++gi.sel[gi.i_sel].i_dst == gi.sel[gi.i_sel].n_dst)
				     gi.sel[gi.i_sel].i_dst = 0;
			} else {
				sound(1);
			}
		/* ړs */
		} else if(joy & TRG_A) {
DO_MOVE:
			sound(0);
			for(i = 1; i <= MOVE_STEP; i++) {
				schedule();
				gi.time++;
				field_disp(i);
			}
			schedule(); /* \O΍ */
			do_move(gi.sel[gi.i_sel].src,
			        gi.sel[gi.i_sel].dst[gi.sel[gi.i_sel].i_dst]);
			/* NAB */
			for(i = 0; i < 4; i++) {
				if(gi.home[i] == CARD_NUL) break;
				if(CARD_NO(gi.home[i]) != (13 - 1)) break;
			}
			if(i == 4) break; /* CLEAR */
			/* ̈ړEړIB */
			gi.n_sel = find_sel(gi.sel);
			if(gi.n_sel == 0) { /* IȂAGAMEOVER */
				gi.gameover = 1;
				break;
			}
			gi.i_sel = 0;
		}

		/* ʕ\B */
		field_disp(0);
	}
	sound(2);

	/* BR}hFNA */
	if((joy & (PAD_UP | PAD_DN | PAD_LF | PAD_RI))
	       == (PAD_UP | PAD_DN | PAD_LF | PAD_RI)) gi.gameover = 0;

	/* IbZ[W\B */
	gi.n_sel = 0; /* I\}̂ */
	if(gi.gameover) {
		str = "GAME OVER";
	} else {
		if(gi.time < best_time) {
			best_time = gi.time;
			str = "BEST TIME";
		} else {
			str = "CLEAR";
		}
	}
	for(i = 0; i < SEC(3); i++) {
		schedule();
		if(joy & TRG_MASK) break;
		field_disp(0);
		x = (DISP_X - strlen(str) * 8) / 2;
		y = (DISP_Y - 10) / 2;
		pceFontSetType(0x81);
		stredge(x, y, str, 0, 3);
	}
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	int i, j, mark, no, col;
	unsigned char cards[52];

	memset(&gi, 0, sizeof gi);

	/* Xy[h``n[gj܂ł̕т܂B */
	i = 0;
	for(mark = 0; mark < 4; mark++) {
		for(no = 0; no < 13; no++) {
			cards[i++] = CARD_MAKE(mark, no);
		}
	}

	/* VbtďDɒu܂B */
	col = 0;
	for(i = 52; i > 0; i--) {	/* i=c薇 */
		j = rand() % i;		/* j=ڂo */
		gi.ba[col][gi.n_ba[col]++] = cards[j];	/* oďDֈړ */
		cards[j] = cards[i - 1];/* oƂɍŌ̃J[hړ */
		col = (col + 1) % 8;
	}

	/* t[Zƃz[Zɂ܂B */
	memset(gi.free, CARD_NUL, sizeof gi.free);
	memset(gi.home, CARD_NUL, sizeof gi.home);

	/* ŏ̈ړEړIB */
	gi.n_sel = find_sel(gi.sel);
	gi.i_sel = 0;
}

/****************************************************************************
 *	sound
 ****************************************************************************/

void
sound(int no)
{
	static PCEWAVEINFO wi;
	const unsigned char* p;

	pceWaveAbort(0);
	switch(no) {
	case 0: p = S1; break;
	case 1: p = S2; break;
	case 2: p = S3; break;
	case 3: p = S4; break;
	default: return;
	}
	memcpy(&wi, p + 8, sizeof(PCEWAVEINFO));
	wi.pData = p + 8 + sizeof(PCEWAVEINFO);
	pceWaveDataOut(0, &wi);
}

/****************************************************************************
 *	stredge
 ****************************************************************************/

void
stredge(int x, int y, const char* str, int outcol, int incol)
{
	pceFontSetBkColor(-1);
	pceFontSetTxColor(outcol);
	pceFontSetPos(x    , y - 1); pceFontPutStr(str);
	pceFontSetPos(x - 1, y    ); pceFontPutStr(str);
	pceFontSetPos(x + 1, y    ); pceFontPutStr(str);
	pceFontSetPos(x    , y + 1); pceFontPutStr(str);
	pceFontSetTxColor(incol);
	pceFontSetPos(x    , y    ); pceFontPutStr(str);
}

/****************************************************************************
 *	timestr
 ****************************************************************************/

void
timestr(char* str/*9oCgȏ*/, int time)
{
	int hh, mm, ss;

	ss = time / FPS;
	mm = ss / 60; ss %= 60;
	hh = mm / 60; mm %= 60;
	if(hh > 99) { hh = 99; mm = 59; ss = 59; }
	sprintf(str, "%02d:%02d:%02d", hh, mm, ss);
}

/****************************************************************************
 *	card_disp
 ****************************************************************************/

/* J[h\܂B
 * [in]
 *	x,y	\ʒu̍W
 *	card	J[hCfbNX
 *	sel	0:ʏ/1:I
 */
void
card_disp(int x, int y, unsigned char card, int sel)
{
	int sx, sy;
	unsigned char back;

	/* I͔̒wi */
	if(card == CARD_NUL && !sel) goto L10;

	/* wi\B */
	back = sel ? CARD_SELECT : CARD_NORMAL;
	sy = CARD_MARK(back) * 24;
	sx = CARD_NO(back) * 16;
	draw_object(&pat, x, y, sx, sy, 15, 23, DRW_NOMAL);
L10:
	/* Oi\B */
	sy = CARD_MARK(card) * 24;
	sx = CARD_NO(card) * 16;
	draw_object(&pat, x, y, sx, sy, 15, 23, DRW_NOMAL);
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp(int step)
{
	int src, dst, col, row, x, y, sel, x1, y1, x2, y2;
	unsigned char card, src_card = 0; /* x} */
	char str[32];
	int ptn[6] = { 0, 1, 2, 0, 3, 4 };

	draw_object(&bg, 128 - (now % 128), 0, 0, 0, DISP_X, DISP_Y, DRW_NOMAL);
	draw_object(&bg,   0 - (now % 128), 0, 0, 0, DISP_X, DISP_Y, DRW_NOMAL);
	draw_object(&ayaka, 40, 0+8/*㉺ʒu*/, 0, 72 * ptn[now / 3/*Ajx*/ % 6], 48, 72, DRW_NOMAL);

	/* KChEXN[pB */
	x1 = y1 = x2 = y2 = 0;
	gi.bottom = DISP_Y;

	/* ړEړoĂB */
	if(gi.n_sel != 0) {
		src = gi.sel[gi.i_sel].src;
		dst = gi.sel[gi.i_sel].dst[gi.sel[gi.i_sel].i_dst];
	} else {
		src = -1;
		dst = -1;
	}

	/* t[Zƃz[Z̕`ɂāF
	 * * t[Zƃz[Z͗דm̃J[hgLĂ܂B
	 *   ƒȊOׂ荇Ƃ́Ag̐FႤ̂ŁAPɋLł܂B
	 *   ɒȊO̕Oɕ\悤AꁨȊȌŕ`܂B
	 *   ɂ́Aړ̈ړJ[h̓E`悪ׂ̘gɗĂ܂܂A
	 *     ܂CtȂł傤(^^;
	 */

	/* t[Z */
	y = 0;
	for(row = 0; row < 2; row++) {
		for(col = 0, x = 0; col < 4; col++, x += 14) {
			card = gi.free[col];
			if((row == 0 && card != CARD_NUL) ||		/* ڂ͒ꂾ */
			   (row == 1 && card == CARD_NUL)) continue;	/* ڂ͒ȊO */
			sel = 0;
			if(SEL_TYPE(src) == SEL_FREE &&
			   SEL_COL(src) == col) { sel = 1; x1 = x; y1 = y; }
			if(SEL_TYPE(dst) == SEL_FREE &&
			   SEL_COL(dst) == col) { sel = 2; x2 = x; y2 = y; }
			if(!step) { /* I */
				card_disp(x, y - gi.top, card, sel);
			} else { /* ړ */
				if(sel == 1) {
					src_card = card;			/* ړJ[h͌ŕ` */
					card_disp(x, y - gi.top, CARD_NUL, 0);	/* ɒʏ\     */
				} else {
					card_disp(x, y - gi.top, card, 0);	/* ړʏ\ */
				}
			}
		}
	}
	if(y + 24 > gi.bottom) gi.bottom = y + 24;

	/* z[Z */
	y = 0;
	for(col = 0; col < 4; col++) {
		for(col = 0, x = 70; col < 4; col++, x += 14) {
			card = gi.home[col];
			if((row == 0 && card != CARD_NUL) ||		/* ڂ͒ꂾ */
			   (row == 1 && card == CARD_NUL)) continue;	/* ڂ͒ȊO */
			sel = 0;
			if(SEL_TYPE(src) == SEL_HOME &&
			   SEL_COL(src) == col) { sel = 1; x1 = x; y1 = y; }
			if(SEL_TYPE(dst) == SEL_HOME &&
			   SEL_COL(dst) == col) { sel = 2; x2 = x; y2 = y; }
			if(!step) { /* I */
				card_disp(x, y - gi.top, card, sel);
			} else { /* ړ */
				if(sel == 1) {
					src_card = card;			/* ړJ[h͌ŕ` */
					card_disp(x, y - gi.top, CARD_NUL, 0);	/* ɒʏ\     */
				} else {
					card_disp(x, y - gi.top, card, 0);	/* ړʏ\ */
				}
			}
		}
	}
	if(y + 24 > gi.bottom) gi.bottom = y + 24;

	/* D */
	for(col = 0, x = 0; col < 8; col++, x += 16) {
		y = 24;
		if(gi.n_ba[col] == 0) {
			card = CARD_NUL;
			sel = 0;
			if(SEL_TYPE(src) == SEL_BA &&
			   SEL_COL(src) == col) { sel = 1; x1 = x; y1 = y; }
			if(SEL_TYPE(dst) == SEL_BA &&
			   SEL_COL(dst) == col) { sel = 2; x2 = x; y2 = y; }
			if(!step) { /* I */
				card_disp(x, y - gi.top, card, sel);
			} else { /* ړ */
				if(sel == 1) {
					src_card = card;			/* ړJ[h͌ŕ` */
					card_disp(x, y - gi.top, CARD_NUL, 0);	/* ɒʏ\     */
				} else {
					card_disp(x, y - gi.top, card, 0);	/* ړʏ\ */
				}
			}
			if(y + 24 > gi.bottom) gi.bottom = y + 24;
		} else {
			for(row = 0; row < gi.n_ba[col]; row++, y += 7) {
				card = gi.ba[col][row];
				sel = 0;
				if(SEL_TYPE(src) == SEL_BA &&
				   SEL_COL(src) == col &&
				   row == gi.n_ba[col] - 1) { sel = 1; x1 = x; y1 = y; }
				if(SEL_TYPE(dst) == SEL_BA &&
				   SEL_COL(dst) == col &&
				   row == gi.n_ba[col] - 1) { sel = 2; x2 = x; y2 = y; }
				if(!step) { /* I */
					card_disp(x, y - gi.top, card, sel);
				} else { /* ړ */
					if(sel == 1) {
						src_card = card;					/* ړJ[h͌ŕ`       */
						if(row == 0) card_disp(x, y - gi.top, CARD_NUL, 0);	/* Ō̃J[hȂʏ\ */
					} else {
						card_disp(x, y - gi.top, card, 0);	/* ړʏ\ */
						if(sel == 2) y2 += 7; /* ړʒuړJ[h艺ւ炷 */
					}
				}
				if(y + 24 > gi.bottom) gi.bottom = y + 24;
			}
		}
	}

	if(!step) { /* I */
		/* KCh */
		if(gi.n_sel != 0) {
			if(x1 != x2 || y1 != y2) {
				y1 -= gi.top;
				y2 -= gi.top;
				render_dashes(&render, x1     , y1     , x2     , y2     , ~(now / 2), dashes, sizeof dashes);
				render_dashes(&render, x1 + 14, y1     , x2 + 14, y2     , ~(now / 2), dashes, sizeof dashes);
				render_dashes(&render, x1     , y1 + 22, x2     , y2 + 22, ~(now / 2), dashes, sizeof dashes);
				render_dashes(&render, x1 + 14, y1 + 22, x2 + 14, y2 + 22, ~(now / 2), dashes, sizeof dashes);
			} else {
				x = x1;
				y = y1 - gi.top;
				x++; render_dashes(&render, x, y, x + 13, y, now / 2, dashes, sizeof dashes); x += 13;
				y++; render_dashes(&render, x, y, x, y + 21, now / 2, dashes, sizeof dashes); y += 21;
				x--; render_dashes(&render, x, y, x - 13, y, now / 2, dashes, sizeof dashes); x -= 13;
				y--; render_dashes(&render, x, y, x, y - 21, now / 2, dashes, sizeof dashes); y -= 21;
			}
		}
	} else { /* ړ */
		x = x1 + (x2 - x1) * step / MOVE_STEP;
		y = y1 + (y2 - y1) * step / MOVE_STEP;
		card_disp(x, y - gi.top, src_card, 0);
	}

	/* I */
	x = 104;
	y = 104;
	if(!step) {
		if(gi.n_sel > 1) {
			if(gi.sel[gi.i_sel].n_dst > 1) {
				x += 16 * 3;	/* ㉺E */
			} else {
				x += 16 * 2;	/* E */
			}
		} else {
			if(gi.sel[gi.i_sel].n_dst > 1) {
				x += 16 * 1;	/* ㉺ */
			}
		}
	}
	draw_object(&pat, 57, 5 - gi.top, x, y, 13, 13, DRW_NOMAL);

	/* XN[ */
	if(joy & PAD_B) {
		gi.top += 4;
	} else {
		gi.top -= 4;
	}
	if(gi.top < 0) gi.top = 0;
	if(gi.top > gi.bottom - DISP_Y) gi.top = gi.bottom - DISP_Y;
	if(gi.top == 0 && gi.top < gi.bottom - DISP_Y) {
		draw_object(&pat, DISP_X - 7, DISP_Y - 12, 168, 104, 7, 12, DRW_NOMAL);
	}

	/* oߎ */
	pceFontSetType(0x82);
	timestr(str, gi.time);
	x = (DISP_X - 4 * 8) / 2;
	y = DISP_Y - 6;
	stredge(x, y, str, 3, 0);
}

/****************************************************************************
 *	find_sel
 ****************************************************************************/

#define AUTO_SEL

/* ړƈړ̑gݍ킹ɂDxBقǗDx
 *	-1	mȈړ(trust()֐Ŕ)
 *	0	t[ -> z[
 *	1	D   -> z[
 *	2	D   -> D(d) vOŔ(8888)
 *	3	t[ -> D(d) vOŔ(9999)
 *	4	D   -> t[
 *	5	D   -> D() vOŔ(8888)
 *	6	t[ -> D() vOŔ(9999)
 */
static const int prior[3][3] = {
    /*dst=        BA  FREE HOME*/
    /*src= BA */{8888,   4,   1},
    /*    FREE*/{9999,  -1,   0},
    /*    HOME*/{  -1,  -1,  -1},
};

static int
comp_sel(const void* _a, const void* _b)
{
	SEL* a = (SEL*)_a;
	SEL* b = (SEL*)_b;
	int a_src = a->src;
	int b_src = b->src;
	int a_dst = a->dst[0];
	int b_dst = b->dst[0];
	int a_prior = prior[SEL_TYPE(a_src)][SEL_TYPE(a_dst)];
	int b_prior = prior[SEL_TYPE(b_src)][SEL_TYPE(b_dst)];

	if(trust(a_src, b_src)) return -1; /* mȈړ */
#ifdef AUTO_SEL
	if(a_prior == 8888) a_prior = gi.n_ba[SEL_COL(a_dst)] != 0 ? 2 : 5; /* D  ->D(2:d/5:) */
	if(b_prior == 8888) b_prior = gi.n_ba[SEL_COL(b_dst)] != 0 ? 2 : 5; /* D  ->D(2:d/5:) */
	if(a_prior == 9999) a_prior = gi.n_ba[SEL_COL(a_dst)] != 0 ? 3 : 6; /* t[->D(3:d/6:) */
	if(b_prior == 9999) b_prior = gi.n_ba[SEL_COL(b_dst)] != 0 ? 3 : 6; /* t[->D(3:d/6:) */
	if(a_prior == b_prior) { /* DxȂʒuقǗDƂ */
		a_prior = (SEL_COL(a_src) << 8 | SEL_COL(a_dst));
		b_prior = (SEL_COL(b_src) << 8 | SEL_COL(b_dst));
	}
#else /*AUTO_SEL*/
	a_prior = a_src << 16 | a_dst;
	b_prior = b_src << 16 | b_dst;
#endif /*AUTO_SEL*/

	return a_prior - b_prior;
}

int
find_sel(SEL sel[52])
{
	int n_sel, col;

	n_sel = 0;

	/***** ړ=D *****/
	/* ëԏ̃J[hړ\łB */
	for(col = 0; col < 8; col++) {
		if(gi.n_ba[col] == 0) continue; /* ͔΂܂ */
		sel[n_sel].src = SEL_MAKE(SEL_BA, col);
		sel[n_sel].n_dst = find_dst(sel[n_sel].src, sel[n_sel].dst);
		if(sel[n_sel].n_dst != 0) { sel[n_sel++].i_dst = 0; }
	}

	/***** ړ=t[Z *****/
	/* SẴJ[hړ\łB */
	for(col = 0; col < 4; col++) {
		if(gi.free[col] == CARD_NUL) continue; /* ͔΂܂ */
		sel[n_sel].src = SEL_MAKE(SEL_FREE, col);
		sel[n_sel].n_dst = find_dst(sel[n_sel].src, sel[n_sel].dst);
		if(sel[n_sel].n_dst != 0) { sel[n_sel++].i_dst = 0; }
	}

	/***** ړ=z[Z *****/
	/* z[ZɈړJ[h͓܂B */

	qsort(sel, n_sel, sizeof *sel, comp_sel);

	return n_sel;
}

/****************************************************************************
 *	find_dst
 ****************************************************************************/

static int _a_src;
static int _b_src;

static int
comp_dst(const void* _a, const void* _b)
{
	int a_src = _a_src;
	int b_src = _b_src;
	int a_dst = *(int*)_a;
	int b_dst = *(int*)_b;
	int a_prior = prior[SEL_TYPE(a_src)][SEL_TYPE(a_dst)];
	int b_prior = prior[SEL_TYPE(b_src)][SEL_TYPE(b_dst)];

	if(trust(a_src, b_src)) return -1; /* mȈړ */
#ifdef AUTO_SEL
	if(a_prior == 8888) a_prior = gi.n_ba[SEL_COL(a_dst)] != 0 ? 2 : 5; /* D  ->D(2:d/5:) */
	if(b_prior == 8888) b_prior = gi.n_ba[SEL_COL(b_dst)] != 0 ? 2 : 5; /* D  ->D(2:d/5:) */
	if(a_prior == 9999) a_prior = gi.n_ba[SEL_COL(a_dst)] != 0 ? 3 : 6; /* t[->D(3:d/6:) */
	if(b_prior == 9999) b_prior = gi.n_ba[SEL_COL(b_dst)] != 0 ? 3 : 6; /* t[->D(3:d/6:) */
	if(a_prior == b_prior) { /* DxȂʒuقǗDƂ */
		a_prior = (SEL_COL(a_src) << 8 | SEL_COL(a_dst));
		b_prior = (SEL_COL(b_src) << 8 | SEL_COL(b_dst));
	}
#else /*AUTO_SEL*/
	a_prior = a_src << 16 | a_dst;
	b_prior = b_src << 16 | b_dst;
#endif /*AUTO_SEL*/

	return a_prior - b_prior;
}

int
find_dst(int src, int dst[52])
{
	int n_dst, col, sel;
	int src_type, src_col;
	int src_card, src_mark, src_no;
	int dst_card, dst_mark, dst_no;

	n_dst = 0;

	/* ړ擾܂BiJ[h͂܂łj */
	src_type = SEL_TYPE(src);
	src_col = SEL_COL(src);

	/* ړɂ... */
	switch(src_type) {
	/***** ړ=D *****/
	case SEL_BA:
		/* ړJ[h擾B */
		src_card = gi.ba[src_col][gi.n_ba[src_col] - 1];
		src_mark = CARD_MARK(src_card);
		src_no = CARD_NO(src_card);
		/***** ړ=D *****/
		for(col = 0; col < 8; col++) {
			if(col == src_col) continue; /* Ȃ΂܂ */
			if(gi.n_ba[col] == 0) {
				/* ɂ͖ňړł܂B(t[ZƓ) */
				sel = SEL_MAKE(SEL_BA, col);
				dst[n_dst++] = sel;
			} else {
				/* FႢ̍~ňړł܂B */
				dst_card = gi.ba[col][gi.n_ba[col] - 1];
				dst_mark = CARD_MARK(dst_card);
				dst_no = CARD_NO(dst_card);
				if((src_mark ^ dst_mark) & 1 && src_no == dst_no - 1) {
					sel = SEL_MAKE(SEL_BA, col);
					dst[n_dst++] = sel;
				}
			}
		}
		/***** ړ=t[Z *****/
		for(col = 0; col < 4; col++) {
			if(gi.free[col] != CARD_NUL) continue; /* 󂫂łȂΔ΂܂ */
			/* ŏ̋ɖňړł܂B */
			sel = SEL_MAKE(SEL_FREE, col);
			dst[n_dst++] = sel;
			break; /* 񂪕ꍇ͍[݂̂Ƃ */
		}
		/***** ړ=z[Z *****/
		col = src_mark; /* ړ}[NɑΉKɂ݈̂ړ\ */
		if(gi.home[col] == CARD_NUL) {
			/* ɂ̓G[X݈̂ړł܂B */
			if(src_no == (1 - 1)) {
				sel = SEL_MAKE(SEL_HOME, col);
				dst[n_dst++] = sel;
			}
		} else {
			/* ňړł܂B */
			dst_card = gi.home[col];
			dst_mark = CARD_MARK(dst_card);
			dst_no = CARD_NO(dst_card);
			if(src_no == dst_no + 1) {
				sel = SEL_MAKE(SEL_HOME, col);
				dst[n_dst++] = sel;
			}
		}
		break;

	/***** ړ=t[Z *****/
	case SEL_FREE:
		/* ړJ[h擾B */
		src_card = gi.free[src_col];
		src_mark = CARD_MARK(src_card);
		src_no = CARD_NO(src_card);
		/***** ړ=D *****/
		for(col = 0; col < 8; col++) {
			if(gi.n_ba[col] == 0) {
				/* ɂ͖ňړł܂B(t[ZƓ) */
				sel = SEL_MAKE(SEL_BA, col);
				dst[n_dst++] = sel;
			} else {
				/* FႢ̍~ňړł܂B */
				dst_card = gi.ba[col][gi.n_ba[col] - 1];
				dst_mark = CARD_MARK(dst_card);
				dst_no = CARD_NO(dst_card);
				if((src_mark ^ dst_mark) & 1 && src_no == dst_no - 1) {
					sel = SEL_MAKE(SEL_BA, col);
					dst[n_dst++] = sel;
				}
			}
		}
		/***** ړ=t[Z *****/
		/* t[Zt[Z̈ړ͖ӖȂ̂ŕsłB */
		/***** ړ=z[Z *****/
		col = src_mark; /* ړ}[NɑΉKɂ݈̂ړ\ */
		if(gi.home[col] == CARD_NUL) {
			/* ɂ̓G[X݈̂ړł܂B */
			if(src_no == (1 - 1)) {
				sel = SEL_MAKE(SEL_HOME, col);
				dst[n_dst++] = sel;
			}
		} else {
			/* ňړł܂B */
			dst_card = gi.home[col];
			dst_mark = CARD_MARK(dst_card);
			dst_no = CARD_NO(dst_card);
			if(src_no == dst_no + 1) {
				sel = SEL_MAKE(SEL_HOME, col);
				dst[n_dst++] = sel;
			}
		}
		break;
	}

	_a_src = src;
	_b_src = src;
	qsort(dst, n_dst, sizeof *dst, comp_dst);

	return n_dst;
}

/****************************************************************************
 *	do_move
 ****************************************************************************/

void
do_move(int src, int dst)
{
	int src_type, src_col;
	int dst_type, dst_col;
	unsigned char card = 0; /* x} */

	/* ړ擾܂BiJ[h͂܂łj */
	src_type = SEL_TYPE(src);
	src_col = SEL_COL(src);

	/* ړ擾܂BiJ[h͂܂łj */
	dst_type = SEL_TYPE(dst);
	dst_col = SEL_COL(dst);

	/* ړɂ... */
	switch(src_type) {
	/***** ړ=t[Z *****/
	case SEL_FREE:
		card = gi.free[src_col];
		       gi.free[src_col] = CARD_NUL;
		break;
	/***** ړ=D *****/
	case SEL_BA:
		card = gi.ba[src_col][--gi.n_ba[src_col]];
		break;
	default:
		DIE();
	}

	/* ړɂ... */
	switch(dst_type) {
	/***** ړ=z[Z *****/
	case SEL_HOME:
		gi.home[dst_col] = card;
		break;
	/***** ړ=D *****/
	case SEL_BA:
		gi.ba[dst_col][gi.n_ba[dst_col]++] = card;
		break;
	/***** ړ=t[Z *****/
	case SEL_FREE:
		gi.free[dst_col] = card;
		break;
	default:
		DIE();
	}
}

/****************************************************************************
 *	trust
 ****************************************************************************/

int
trust(int src, int dst)
{
	unsigned char src_card = 0; /* x} */
	int src_type, src_col;
	int src_mark, src_no;

	/* ړ悪z[ZłȂ΁AmȈړł͂ȂB */
	if(SEL_TYPE(dst) != SEL_HOME) return 0;

	/* ړJ[h擾B */
	src_type = SEL_TYPE(src);
	src_col = SEL_COL(src);
	switch(src_type) {
	case SEL_FREE:
		src_card = gi.free[src_col];
		break;
	case SEL_BA:
		src_card = gi.ba[src_col][gi.n_ba[src_col] - 1];
		break;
	default:
		DIE();
	}
	src_mark = CARD_MARK(src_card);
	src_no = CARD_NO(src_card);

	/* G[XȂɊmB */
	if(src_no == (1 - 1)) return 1;

	/* ΐF̂Ꮗʂ̃J[hɎcĂAmȈړł͂ȂB */
	if(src_mark & 1) {
		if(gi.home[0] == CARD_NUL) return 0;
		if(gi.home[2] == CARD_NUL) return 0;
		if(CARD_NO(gi.home[0]) < src_no - 1) return 0;
		if(CARD_NO(gi.home[2]) < src_no - 1) return 0;
	} else {
		if(gi.home[1] == CARD_NUL) return 0;
		if(gi.home[3] == CARD_NUL) return 0;
		if(CARD_NO(gi.home[1]) < src_no - 1) return 0;
		if(CARD_NO(gi.home[3]) < src_no - 1) return 0;
	}

	return 1;
}
